<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "config.php" );
require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

foreach ( $_POST as $postvar => $postval )
{
	$$postvar = $postval;
}

$userdata = array();
$userdata = AuthenticateUser();
if ( $userdata["authstatus"] != 1 )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

$isadmin = CheckUserAdmin();

$profiledata = array();
$profiledata = LoadProfile( $whichuser );

if ( $isadmin == FALSE )
{
	GenerateHeader( "EverList - Manage Users", TRUE, TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "You must be an admin to use this function.";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

$resetuser = array();
$resetuser = LoadUser( $whichuser );

if ( $resetuser["success"] == FALSE )
{
	GenerateHeader( "EverList - Manage Users", TRUE, TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "<b>" . $resetuser["errmsg"] . "</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}
else if ( strcmp( $resetuser["status"], "SUPERUSER" ) == 0 )
{
	GenerateHeader( "EverList - Manage Users", TRUE, TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "<b>You cannot perform this action on the superuser account!</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

$resetprofile = array();
$resetprofile = LoadProfile( $whichuser );

if ( $resetprofile["success"] == FALSE )
{
	GenerateHeader( "EverList - Manage Users", TRUE, TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "<b>" . $resetprofile["errmsg"] . "</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

if ( $formstage == 1 && strcasecmp( $doreset, "YES" ) == 0 )
{
	$newpassword = NULL;
	
	$salt = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890-_-_";
	
	$howmany = mt_rand( 6, 12 );
	
	for ( $saltloop = 1; $saltloop <= $howmany; $saltloop++ )
	{
		$whichsalt = mt_rand( 0, strlen( $salt ) - 1 );
		
		$newpassword .= $salt{$whichsalt};
	}
	
	$newpasswordb = md5( $newpassword );
	
	$query = "update users set password='$newpasswordb'";
	$query .= " where userid='$whichuser'";
	$resulttl1 = mysql_query( $query ) or die( "Query '$query' failed for resulttl1 in resetpassword.php : " . mysql_error() );
	
	$subject = "EverList Password Reset!";
	
	$msgbody = "Dear " . $resetprofile["fullname"] . ",";
	$msgbody .= "\r\n\r\n";
	$msgbody .= "Your password has been reset by the following admin:\r\n\r\n";
	$msgbody .= "Name:  " . $profiledata["fullname"] . "\r\n";
	$msgbody .= "Email:  " . $userdata["email"] . "\r\n";
	$msgbody .= "IP:  $ipb\r\n\r\n";
	$msgbody .= "Your new password is:  $newpassword\r\n\r\n";
	$msgbody .= "It is strongly recommended that you login to your account and change your ";
	$msgbody .= "password by clicking on \"My Account\" then \"Change Password\".\r\n\r\n";
	$msgbody .= "If you did not request that your password be reset, please report this to ";
	$msgbody .= "the forum owner immediately!\r\n\r\n";
	$msgbody .= "--EverList Mailer";
	
	$toemail = $resetuser["email"];
	
	$mailresult = mail( $toemail, $subject, $msgbody, 
		// Email header
		"From: " . $mailfrom . "\r\n" 
		. "Reply-To: " . $replyto . "\r\n" 
		. "Content-type: text/plain\r\n" 
		. "X-mailer: PHP/" . phpversion() );
	
	header( "Location: manageusers.php?whichuser=$whichuser&msg=Password Reset Successfully!" );
	die();
}
else if ( $formstage == 1 )
{
	header( "Location: manageusers.php?whichuser=$whichuser&msg=Operation Aborted." );
	die();
}

GenerateHeader( "EverList - Manage Users", TRUE, TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

?>
<table border="0" cellpadding="0" cellspacing="0" width="750">
<tr>
<td><img src="images/space1px.gif" width="15" height="1" alt="" /></td>
<td>
<table border="0" cellpadding="0" cellspacing="0">
<tr>

<td><img src="images/space1px.gif" width="20" height="1" alt="" /></td>

<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
<td bgcolor="#40AA40"><a href="control_panel.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Your Profile</b></span></a></td>
<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>

<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
<td bgcolor="#40AA40"><a href="changepassword.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Change Password</b></span></a></td>
<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>

<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
<td bgcolor="#40AA40"><a href="subscriptions.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Subscriptions</b></span></a></td>
<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>

<?php
if ( IsModerator( $profiledata ) 
	|| $isadmin == TRUE )
{
	?>
	<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
	<td bgcolor="#40AA40"><a href="moderate.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Manage Forums</b></span></a></td>
	<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>
	
	<?php
}

if ( $isadmin == TRUE )
{
	?>
	<td align="right"><input type="image" width="7" height="17" border="0" src="images/subsel_left.gif" name="tab_advanced"></td>
	<td bgcolor="#90EE90"><a href="#"><span style="font-size: 8pt; color: darkgreen; font-family: Courier New"><b>Manage Users</b></span></a></td>
	<td align="left"><input type="image" width="7" height="17" border="0" src="images/subsel_right.gif" name="tab_advanced"></td>
	
	<?php
}

?>
</tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="735">
<tr>
<td width="8"><img src="images/sub_topleft.gif" width="8" height="8" alt="" /></td>
<td bgcolor="#90EE90"><img src="images/space1px.gif" width="716" height="1" alt="" /></td>
<td width="11"><img src="images/sub_topright.gif" width="11" height="8" alt="" /></td>
</tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="735">

<tr>
<td bgcolor="#90EE90"><img src="images/space1px.gif" width="8" height="1" alt="" /></td>
<td bgcolor="#90EE90" align="center">

<h2 style="color: #005000">Reset Password for <?php print $resetuser["email"]; ?>?</h2>

<form name="pickuser" id="pickuser" action="resetpassword.php" method="POST">

<input type="hidden" name="formstage" id="formstage" value="1" />
<input type="hidden" name="whichuser" id="whichuser" value="<?php print $whichuser; ?>" />

<input type="submit" name="doreset" id="doreset" value="NO" /> &nbsp;
<input type="submit" name="doreset" id="doreset" value="YES" />

<?php
GenerateBottom();
GenerateFooter();
