<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/* Generates the HTML code for the user login box.  --Kris */
function UserLogin( $loginmessage = NULL, $standalone = TRUE )
{
	require( "config.php" );
	require_once( "common.php" );
	
	if ( $standalone == TRUE )
	{
		GenerateHeader( "EverList - Login", TRUE );
		GenerateTop();
	}
	
	if ( $loginmessage != NULL )
	{
		print "<b style=\"color: red; font-size: 120%\">$loginmessage</b><br />";
	}
	
	if ( strcasecmp( $thispage, "activate.php" ) == 0 
		|| strcasecmp( $thispage, "authenticate_user_login.php" ) == 0 )
	{
		$refpage = "all_forums.php";
	}
	else
	{
		$refpage = $thispage;
	}
	
	?>
	<form name="loginform" id="loginform" action="authenticate_user_login.php" method="POST">
	
	<input type="hidden" name="refpage" id="refpage" value="<?php print $refpage; ?>" />
	
	<table border="1" cellspacing="0" cellpadding="0">
	<tr>
	<td bgcolor="navy" align="center">
	<b style="color: yellow">User Login</b>
	</td>
	</tr>
	<tr>
	<td>
	<table border="1" cellspacing="2" cellpadding="2">
	<tr>
	<td align="right">
	<b>Username:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="login_username" id="login_username" size="30" maxlength="255" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b>Password:</b> &nbsp;
	</td>
	<td>
	<input type="password" name="login_password" id="login_password" size="30" />
	</td>
	</tr>
	</table>
	</td>
	</tr>
	<tr>
	<td align="center">
	<input type="submit" name="submitlogin" id="submitlogin" value="Submit" />
	</td>
	</tr>
	</table>
	
	</form>
	
	<br />
	
	<b style="font-size: 14pt"><a href="register.php">Click HERE to Register!</a></b>
	
	<script language="JavaScript">
	document.loginform.login_username.focus();
	</script>
	
	<?php
	if ( $standalone == TRUE )
	{
		GenerateFooter();
	}
}

/* Authenticates login info with the database and acts accordingly.  --Kris */
function AuthenticateUserLogin( $postarray )
{
	require( "config.php" );
	
	foreach ( $postarray as $postvar => $postval )
	{
		$$postvar = $postval;
	}
	
	if ( trim( $login_username ) == NULL || trim( $login_password ) == NULL )
	{
		UserLogin( "You must specify a username and password!" );
		die();
	}
	
	$userdata = array();
	$userdata["logindata"] = array();
	$userdata["logindata"] = $postarray;
	
	$query = "select * from users where username='" . addslashes( $login_username ) . "'";
	$query .= " AND password='" . md5( $login_password ) . "'";
	$query .= " AND status<>'BANNED'";
	$loginquery = $query;
	$resultAUL1 = mysql_query( $query ) or die( "Query '$query' failed for resultAUL1 in user_functions.php : " . mysql_error() );
	
	$userdata["database"] = array();
	while ( $line = mysql_fetch_array( $resultAUL1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultAUL1, $sqloop );
			$userdata["database"][$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	/* Check for email address in place of username (if enabled, see config.php).  --Kris */
	if ( strcasecmp( $login_username, $userdata["database"]["username"] ) 
		&& $allowemaillogins == TRUE )
	{
		$query = str_replace( "username", "email", $loginquery );
		$resultAUL3 = mysql_query( $query ) or die ( "Query '$query' failed for resultAUL3 in user_functions.php : " . mysql_error() );
		
	
		$userdata["database"] = array();
		while ( $line = mysql_fetch_array( $resultAUL3, MYSQL_ASSOC ) )
		{
			$sqloop = 0;
			foreach ( $line as $col_value )
			{
				$fieldname = mysql_field_name( $resultAUL3, $sqloop );
				$userdata["database"][$fieldname] = $col_value;
				$sqloop++;
			}
		}
		
		if ( strcasecmp( $login_username, $userdata["database"]["email"] ) )
		{
			UserLogin( "Invalid username and/or password!" );
			die();
		}
		else
		{
			$userdata["logindata"]["login_username"] = $userdata["database"]["username"];
			$login_username = $userdata["database"]["username"];
		}
	}
	else if ( strcasecmp( $login_username, $userdata["database"]["username"] ) )
	{
		UserLogin( "Invalid username and/or password!" );
		die();
	}
	
	$userdata["session"] = array();
	$sid = GenerateSID();
	$userdata["session"]["sessionid"] = md5( $sid );
	$userdata["session"]["loggedon"] = 1;
	$userdata["session"]["lastlogontimestamp"] = time();
	$userdata["session"]["lastactiontimestamp"] = time();
	$userdata["session"]["currentip"] = $ipb;
	
	$query = "update users set";
	foreach ( $userdata["session"] as $svar => $sval )
	{
		$query .= " " . $svar . "='" . $sval . "',";
	}
	$query = substr( $query, 0, strlen( $query ) - 1 );
	$query .= " where username='" . addslashes( $login_username ) . "'";
	$resultAUL2 = mysql_query( $query );
	
	if ( !is_numeric( $userdata["database"]["logintimeoutminutes"] ) 
		|| $userdata["database"]["logintimeoutminutes"] == NULL 
		|| $userdata["database"]["logintimeoutminutes"] <= 0 )
	{
		$success = setcookie( "sid", $sid );
		$_COOKIE["sid"] = $sid;
	}
	else
	{
		//$success = setcookie( "sid", $sid, time() + ($userdata["database"]["logintimeoutminutes"] * 60) );
		$success = setcookie( "sid", $sid );
		$_COOKIE["sid"] = $sid;
	}
	
	if ( $success == FALSE )
	{
		die( "ERROR!  Unable to set login cookie!  Please make sure your browser is configured to support cookies." );
	}
	
	return $userdata;
}

function GenerateControlPanel( $postdata = array() )
{
	require_once( "config.php" );
	require_once( "common.php" );
	
	$userdata = array();
	$userdata = AuthenticateUser();
	if ( $userdata["authstatus"] != 1 )
	{
		UserLogin( $userdata["authstatus"] );
		die();
	}
	
	$isadmin = CheckUserAdmin();
	
	/* Uncomment below for DEBUG.  --Kris */
	/*
	$isadmin = CheckUserAdmin();
	print_r( $_COOKIE );
	print_r( $_SERVER );
	print "<b>$thispage</b>";
	*/
	
	foreach ( $postdata as $postvar => $postval )
	{
		$$postvar = $postval;
	}
	
	GenerateHeader( "EverList Panel", TRUE, TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	$profiledata = array();
	$profiledata = $topdata["profiledata"];
	
	/* Form validation.  --Kris */
	$errtxt = NULL;
	if ( $formstage == 1 )
	{
		$username = trim( $username );
		$email = trim( $email );
		$fullname = trim( $fullname );
		$avatar = trim( $avatar );
		$website = trim( $website );
		$title = trim( $title );
		$street = trim( $street );
		$city = trim( $city );
		$state = trim( $state );
		$zip = trim( $zip );
		$country = trim( $country );
		
		if ( $email == NULL || $fullname == NULL )
		{
			$errtxt .= "You must fill-out ALL required fields!<br />";
			if ( $email == NULL )
			{
				$emailcolor = "red";
			}
			if ( $fullname == NULL )
			{
				$fullnamecolor = "red";
			}
		}
		
		if ( !ValidEmail( $email ) )
		{
			$errtxt .= "You must specify a VALID email address!<br />";
			$emailcolor = "red";
		}
		
		$emailcheck = array();
		$emailcheck = LoadUserByEmail( $email );
		
		if ( $emailcheck["success"] == TRUE && strcasecmp( $emailcheck["email"], $userdata["email"] ) )
		{
			$errtxt .= "That email address has already been registered to another user!<br />";
			$emailcolor = "red";
		}
		
		if ( $dobmonth != NULL || $dobday != NULL || $dobyear != NULL )
		{
			if ( $dobmonth == NULL || $dobday == NULL || $dobyear == NULL )
			{
				$errtxt .= "You have specified an invalid date of birth!<br />";
				$dobcolor = "red";
			}
			
			if ( checkdate( $dobmonth, $dobday, $dobyear ) == FALSE )
			{
				$errtxt .= "You have specified an invalid date of birth!<br />";
				$dobcolor = "red";
			}
			
			$dob = "$dobyear-$dobmonth-$dobday";
			
			$cur_time = time();
			$dobtime = strtotime( $dob );
			
			/*
			 * Note - Humor aside, the 2037 hard limit is an unavoidable temporary fix due to 
			 * an inherent bug built into PHP.  Anything past the year 2037 cannot generate a 
			 * timestamp in any PHP function (including strtotime()).  Some have described 
			 * this as "Unix's Y2K", but I've been able to reproduce this exact same error on 
			 * my Windows machine.  The strtotime() function will return FALSE if you input a 
			 * year greater than 2037, regardless of format, rendering the date validation 
			 * meaningless.  This "|| intval( $dobyear ) > 2037" contingency should be removed 
			 * ONLY if/when this bug in PHP has been fixed (hopefully before the year 2038)!
			 *
			 * In the meantime, you can monitor the bug I sent to the PHP dev team here:
			 * 
			 * http://bugs.php.net/bug.php?id=45713
			 *
			 * --Kris
			 * 08.04.2008
			 * 
			 */
			if ( $cur_time - $dobtime < 0 
				|| intval( $dobyear ) > 2037 )
			{
				$errtxt .= "The Vulcan Science Directorate has determined that time travel is impossible.<br />";
				$dobcolor = "red";
			}
			else if ( $cur_time - $dobtime < pow( 60, 2 ) * 24 * 365.25 * 13 )
			{
				$errtxt .= "You must be at least 13 years old to use this listserv!<br />";
				$dobcolor = "red";
			}
			
			if ( strlen( $bio ) > 512000 )
			{
				$errtxt .= "Bio cannot exceed 500 KB in size!<br />";
				$biocolor = "red";
			}
			
			if ( $avatar != NULL )
			{
				if ( strcasecmp( substr( $avatar, -4, 4 ), ".jpg" ) 
					&& strcasecmp( substr( $avatar, -4, 4 ), ".gif" ) 
					&& strcasecmp( substr( $avatar, -4, 4 ), ".png" ) 
					&& strcasecmp( substr( $avatar, -4, 4 ), ".bmp" ) 
					&& strcasecmp( substr( $avatar, -4, 4 ), ".tif" ) 
					&& strcasecmp( substr( $avatar, -4, 4 ), ".img" ) 
					&& strcasecmp( substr( $avatar, -5, 5 ), ".jpeg" ) )
				{
					$errtxt .= "Avatar must be in a valid static image format!<br />";
					$avatarcolor = "red";
				}
			}
			
			if ( $website != NULL && strcasecmp( substr( $website, 0, 7 ), "http://" ) 
				&& strcasecmp( substr( $website, 0, 8 ), "https://" ) )
			{
				$website = "http://" . $website;
			}
			
			if ( $homephoneac != NULL || $homephonepre != NULL || $homephonesuf != NULL )
			{
				if ( $homephoneac == NULL || $homephonepre == NULL || $homephonesuf == NULL 
					|| !is_numeric( $homephoneac ) || !is_numeric( $homephonepre ) 
					|| !is_numeric( $homephonesuf ) )
				{
					$errtxt .= "You have specified an invalid home phone number!<br />";
					$homephonecolor = "red";
				}
				
				$homephone = "($homephoneac) $homephonepre-$homephonesuf";
			}
			
			if ( $workphoneac != NULL || $workphonepre != NULL || $workphonesuf != NULL )
			{
				if ( $workphoneac == NULL || $workphonepre == NULL || $workphonesuf == NULL 
					|| !is_numeric( $workphoneac ) || !is_numeric( $workphonepre ) 
					|| !is_numeric( $workphonesuf ) )
				{
					$errtxt .= "You have specified an invalid work phone number!<br />";
					$workphonecolor = "red";
				}
				
				$workphone = "($workphoneac) $workphonepre-$workphonesuf";
			}
			
			if ( $cellphoneac != NULL || $cellphonepre != NULL || $cellphonesuf != NULL )
			{
				if ( $cellphoneac == NULL || $cellphonepre == NULL || $cellphonesuf == NULL 
					|| !is_numeric( $cellphoneac ) || !is_numeric( $cellphonepre ) 
					|| !is_numeric( $cellphonesuf ) )
				{
					$errtxt .= "You have specified an invalid cell phone number!<br />";
					$cellphonecolor = "red";
				}
				
				$cellphone = "($cellphoneac) $cellphonepre-$cellphonesuf";
			}
			
			//I'm not gonna worry about validating international addresses.
			//If you'd like to give it a shot, go for it.  --Kris
		}
	}
	
	if ( $errtxt != NULL )
	{
		print "<b style=\"color: 880000; font-size: 14pt\">There were errors in your submission:</b><br />";
		print "<b style=\"color: red\">$errtxt</b><br /><br />";
		$formstage = NULL;
	}
	
	/* Form processing.  --Kris */
	if ( $formstage == 1 )
	{
		$cur_time = time();
		
		$username = addslashes( $username );
		
		$sid = $_COOKIE["sid"];
		
		$sidmd5 = md5( $sid );
		
		$query = "update users set email='$email'";
		$query .= " where sessionid='$sidmd5'";
		$resultCP1 = mysql_query( $query ) or die( "Query '$query' failed for resultCP1 in user_functions.php : " . mysql_error() );
		
		$fullname = addslashes( $fullname );
		$title = addslashes( $title );
		$website = addslashes( $website );
		$avatar = addslashes( $avatar );
		$street = addslashes( $street );
		$city = addslashes( $city );
		$state = addslashes( $state );
		$zip = addslashes( $zip );
		$country = addslashes( $country );
		$bio = addslashes( $bio );
		
		$query = "update profiles set fullname='$fullname', title='$title', website='$website', ";
		$query .= "avatarurl='$avatar', homephone='$homephone', cellphone='$cellphone', ";
		$query .= "workphone='$workphone', street='$street', city='$city', state='$state', ";
		$query .= "zip='$zip', country='$country', dob='$dob', bio='$bio', ";
		$query .= "workphoneext='$workphoneext'";
		$query .= " where userid='" . $userdata["userid"] . "'";
		$resultCP2 = mysql_query( $query ) or die( "Query '$query' failed for resultCP2 in user_functions.php : " . mysql_error() );
		
		print "<h3>Your changes have been saved!</h3>";
		
		$userdata = LoadUserByEmail( $email );
		$profiledata = LoadProfile( $userdata["userid"] );
	}
		
	$profiledata["bio"] = str_replace( chr(13), "", $profiledata["bio"] );
	$profiledata["bio"] = str_replace( "\n", "", $profiledata["bio"] );
	$profiledata["bio"] = str_replace( "\r", "", $profiledata["bio"] );
	$profiledata["bio"] = str_replace( "'", "\\'", $profiledata["bio"] );
	
	?>
	<table border="0" cellpadding="0" cellspacing="0" width="750">
	<tr>
	<td><img src="images/space1px.gif" width="15" height="1" alt="" /></td>
	<td>
	<table border="0" cellpadding="0" cellspacing="0">
	<tr>
	
	<td><img src="images/space1px.gif" width="20" height="1" alt="" /></td>
	
	<td align="right"><img src="images/subsel_left.gif" width="7" height="17" alt="" /></td>
	<td bgcolor="#90EE90"><a href="#"><span style="font-size: 8pt; color: darkgreen; font-family: Courier New"><b>Your Profile</b></span></a></td>
	<td align="left"><img src="images/subsel_right.gif" width="7" height="17" alt="" /></td>
	
	<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
	<td bgcolor="#40AA40"><a href="changepassword.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Change Password</b></span></a></td>
	<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>
	
	<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
	<td bgcolor="#40AA40"><a href="subscriptions.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Subscriptions</b></span></a></td>
	<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>
	
	<?php
	if ( IsModerator( $profiledata ) 
		|| $isadmin == TRUE )
	{
		?>
		<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
		<td bgcolor="#40AA40"><a href="moderate.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Manage Forums</b></span></a></td>
		<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>
		
		<?php
	}
	
	if ( $isadmin == TRUE )
	{
		?>
		<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
		<td bgcolor="#40AA40"><a href="manageusers.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Manage Users</b></span></a></td>
		<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>
		
		<?php
	}
	
	?>
	</tr>
	</table>
	
	
	<table border="0" cellpadding="0" cellspacing="0" width="735">
	<tr>
	<td width="8"><img src="images/sub_topleft.gif" width="8" height="8" alt="" /></td>
	<td bgcolor="#90EE90"><img src="images/space1px.gif" width="716" height="1" alt="" /></td>
	<td width="11"><img src="images/sub_topright.gif" width="11" height="8" alt="" /></td>
	</tr>
	</table>
	
	<table border="0" cellpadding="0" cellspacing="0" width="735">
	
	<tr>
	<td bgcolor="#90EE90"><img src="images/space1px.gif" width="8" height="1" alt="" /></td>
	<td bgcolor="#90EE90" align="center">
	
	<?php
	
	$usernamecolor = "black";
	$passwordcolor = "black";
	$passwordretypecolor = "black";
	$emailcolor = "black";
	$fullnamecolor = "black";
	$dobcolor = "black";
	$biocolor = "black";
	$avatarcolor = "black";
	$websitecolor = "black";
	$titlecolor = "black";
	$homephonecolor = "black";
	$workphonecolor = "black";
	$cellphonecolor = "black";
	$streetcolor = "black";
	$citycolor = "black";
	$statecolor = "black";
	$zipcolor = "black";
	$countrycolor = "black";
	
	$dobyear = substr( $profiledata["dob"], 0, 4 );
	$dobmonth = substr( $profiledata["dob"], 5, 2 );
	$dobday = substr( $profiledata["dob"], 8, 2 );
	
	$homephoneac = substr( $profiledata["homephone"], 1, 3 );
	$homephonepre = substr( $profiledata["homephone"], 6, 3 );
	$homephonesuf = substr( $profiledata["homephone"], 10, 4 );
	
	$workphoneac = substr( $profiledata["workphone"], 1, 3 );
	$workphonepre = substr( $profiledata["workphone"], 6, 3 );
	$workphonesuf = substr( $profiledata["workphone"], 10, 4 );
	
	$cellphoneac = substr( $profiledata["cellphone"], 1, 3 );
	$cellphonepre = substr( $profiledata["cellphone"], 6, 3 );
	$cellphonesuf = substr( $profiledata["cellphone"], 10, 4 );
	
	if ( $dobyear == "0000" )
	{
		$dobyear = NULL;
	}
	
	?>
	<h2 style="color: #005000">Edit Profile</h2>
	
	<form name="regform" id="regform" action="control_panel.php" method="POST">
	
	<input type="hidden" name="formstage" value="1" />
	
	<table border="1" bordercolor="lime" cellspacing="0" cellpadding="0">
	<tr>
	<td align="center" bgcolor="#227722">
	<b style="color: yellow">Required Information</b>
	</td>
	</tr>
	<tr>
	<td align="center" bgcolor="#AAFFAA">
	
	<table border="0" cellspacing="2" cellpadding="2" width="100%">
	<tr>
	<td align="right">
	<b style="color: <?php print $usernamecolor; ?>">Username:</b> &nbsp;
	</td>
	<td>
	<input readonly="readonly" type="text" name="username" id="username" value="<?php print $userdata["username"]; ?>" size="30" maxlength="20" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $passwordcolor; ?>">Password:</b> &nbsp;
	</td>
	<td>
	<a class="darklink" href="changepassword.php">Change Password</a>
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $emailcolor; ?>">Email Address:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="email" id="email" value="<?php print $userdata["email"]; ?>" size="30" maxlength="255" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $fullnamecolor; ?>">Your Name:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="fullname" id="fullname" value="<?php print $profiledata["fullname"]; ?>" size="30" maxlength="20" />
	</td>
	</tr>
	</table>
	
	</td>
	</tr>
	</table>
	
	<br />
	
	<table border="1" bordercolor="green" cellspacing="0" cellpadding="0">
	<tr>
	<td align="center" bgcolor="#227722">
	<b style="color: lime">Optional Profile Info</b>
	</td>
	</tr>
	<tr>
	<td align="center" bgcolor="#C0F3C0">
	
	<table border="0" cellspacing="2" cellpadding="2" width="100%">
	<tr>
	<td align="right">
	<b style="color: <?php print $dobcolor; ?>">Date of Birth:</b> &nbsp;
	</td>
	<td>
	<select name="dobmonth" id="dobmonth">
	<option value="">-- Month --</option>
	<option value="01">January</option>
	<option value="02">February</option>
	<option value="03">March</option>
	<option value="04">April</option>
	<option value="05">May</option>
	<option value="06">June</option>
	<option value="07">July</option>
	<option value="08">August</option>
	<option value="09">September</option>
	<option value="10">October</option>
	<option value="11">November</option>
	<option value="12">December</option>
	</select> 
	<select name="dobday" id="dobday">
	<option value="">Day</option>
	<?php
	for ( $dloop = 1; $dloop <= 31; $dloop++ )
	{
		if ( $dloop < 10 )
		{
			$daytext = "0" . "$dloop";
		}
		else
		{
			$daytext = "$dloop";
		}
		
		?>
		<option value="<?php print $daytext; ?>"><?php print $daytext; ?></option><?php
	}
	?>
	</select> 
	<input type="text" name="dobyear" id="dobyear" value="<?php print $dobyear; ?>" size="3" maxlength="4" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $biocolor; ?>">Bio:</b> &nbsp;
	</td>
	<td>
	<textarea name="bio" id="bio" rows="2" cols="2"><?php print $profiledata["bio"]; ?></textarea>
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $avatarcolor; ?>">Avatar URL:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="avatar" id="avatar" value="<?php print $profiledata["avatarurl"]; ?>" size="68" maxlength="255" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $websitecolor; ?>">Website:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="website" id="website" value="<?php print $profiledata["website"]; ?>" size="68" maxlength="255" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $titlecolor; ?>">Occupation:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="title" id="title" value="<?php print $profiledata["title"]; ?>" size="68" maxlength="255" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $homephonecolor; ?>">Home Phone:</b> &nbsp;
	</td>
	<td>
	( <input type="text" name="homephoneac" id="homephoneac" value="<?php print $homephoneac; ?>" size="2" maxlength="3" /> ) 
	<input type="text" name="homephonepre" id="homephonepre" value="<?php print $homephonepre; ?>" size="2" maxlength="3" /> - 
	<input type="text" name="homephonesuf" id="homephonesuf" value="<?php print $homephonesuf; ?>" size="3" maxlength="4" /> 
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $workphonecolor; ?>">Work Phone:</b> &nbsp;
	</td>
	<td>
	( <input type="text" name="workphoneac" id="workphoneac" value="<?php print $workphoneac; ?>" size="2" maxlength="3" /> ) 
	<input type="text" name="workphonepre" id="workphonepre" value="<?php print $workphonepre; ?>" size="2" maxlength="3" /> - 
	<input type="text" name="workphonesuf" id="workphonesuf" value="<?php print $workphonesuf; ?>" size="3" maxlength="4" /> &nbsp;
	<b>Ext.</b> <input type="text" name="workphoneext" id="workphoneext" value="<?php print $profiledata["workphoneext"]; ?>" size="3" maxlength="10" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $cellphonecolor; ?>">Cell:</b> &nbsp;
	</td>
	<td>
	( <input type="text" name="cellphoneac" id="cellphoneac" value="<?php print $cellphoneac; ?>" size="2" maxlength="3" /> ) 
	<input type="text" name="cellphonepre" id="cellphonepre" value="<?php print $cellphonepre; ?>" size="2" maxlength="3" /> - 
	<input type="text" name="cellphonesuf" id="cellphonesuf" value="<?php print $cellphonesuf; ?>" size="3" maxlength="4" /> 
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $streetcolor; ?>">Street:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="street" id="street" value="<?php print $profiledata["street"]; ?>" size="68" maxlength="255" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $citycolor; ?>">City:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="city" id="city" value="<?php print $profiledata["city"]; ?>" size="68" maxlength="255" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $statecolor; ?>">State/Province:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="state" id="state" value="<?php print $profiledata["state"]; ?>" size="68" maxlength="255" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $zipcolor; ?>">Zip Code:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="zip" id="zip" value="<?php print $profiledata["zip"]; ?>" size="10" maxlength="255" />
	</td>
	</tr>
	<tr>
	<td align="right">
	<b style="color: <?php print $countrycolor; ?>">Country:</b> &nbsp;
	</td>
	<td>
	<input type="text" name="country" id="country" value="<?php print $profiledata["country"]; ?>" size="68" maxlength="255" />
	</td>
	</tr>
	</table>
	
	</td>
	</tr>
	</table>
	
	<br />
	
	<input type="submit" name="submitform" value="Save Changes" />
	
	</form>
	
	<script language="JavaScript">
	document.regform.dobmonth.value='<?php print $dobmonth; ?>';
	document.regform.dobday.value='<?php print $dobday; ?>';
	document.regform.bio.value='<?php print $profiledata["bio"]; ?>';
	</script>
	
	</td>
	
	<td bgcolor="#90EE90" valign="TOP">
	
	<img src="images/space1px.gif" height=13 width=13></td>
	
	<td bgcolor="#90EE90"><img src="images/space1px.gif" width="8" height="1" /></td>
	
	</tr>
	</table>
	
	</td>
	</tr>
	
	<tr>
	<td></td>
	<td>
	
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
	<td width="8"><img src="images/botleftb.gif" width="8" height="8" alt="" /></td>
	<td bgcolor="#90EE90"><img src="images/space1px.gif" width="1" height="8" alt="" /></td>
	
	<td width="11"><img src="images/botrightb.gif" width="11" height="8" alt="" /></td>
	</tr>
	</table>
	
	</td>
	</tr>
	
	</table>
	
	<?php
	GenerateBottom();
	GenerateFooter();
}

function AuthenticateUser()
{
	require_once( "config.php" );
	
	if ( $_COOKIE["sid"] == NULL )
	{
		return array( "authstatus" => "You are not logged-in!" );
	}
	
	$query = "select * from users where sessionid='" . md5( $_COOKIE["sid"] ) . "'";
	$resultAU1 = mysql_query( $query ) or die( "Query '$query' failed for resultAU1 in user_functions.php : " . mysql_error() );
	
	$userdata = array();
	while ( $line = mysql_fetch_array( $resultAU1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultAU1, $sqloop );
			$userdata[$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( strcmp( $userdata["sessionid"], md5( $_COOKIE["sid"] ) ) 
		|| $userdata["loggedon"] != 1 )
	{
		/* Uncomment below for DEBUG.  --Kris */
		/*
		print_r( $userdata );
		print_r( $_COOKIE );
		print md5( $_COOKIE["sid"] );
		*/
		return array( "authstatus" => "You are not logged-in!" );
	}
	
	/* Check for expired login; don't rely on the browser to do so.  --Kris */
	if ( time() >= $userdata["lastactiontimestamp"] + ($userdata["logintimeoutminutes"] * 60) 
		&& $userdata["logintimeoutminutes"] > 0 )
	{
		$query = "update users set loggedon='0' where userid='" . $userdata["userid"] . "'";
		$resultAU2 = mysql_query( $query ) or die( "Query '$query' failed for resultAU2 in user_functions.php : " . mysql_error() );
		
		return array( "authstatus" => "Your session has expired!" );
	}
	
	/* Ok, we're authenticated!  Now let's update the DB and send the return array.  --Kris */
	$userdata["lastactiontimestamp"] = time();
	
	$query = "update users set lastactiontimestamp='" . $userdata["lastactiontimestamp"] . "' where userid='" . $userdata["userid"] . "'";
	$resultAU3 = mysql_query( $query ) or die( "Query '$query' failed for resultAU3 in user_functions.php : " . mysql_error() );
	
	$userdata["authstatus"] = 1;
	
	return $userdata;
}

function CheckUserAdmin( $superuseronly = FALSE )
{
	require_once( "config.php" );
	
	if ( $_COOKIE["sid"] == NULL )
	{
		return FALSE;
	}
	
	$query = "select status from users where sessionid='" . md5( $_COOKIE["sid"] ) . "'";
	$resultCUA1 = mysql_query( $query ) or die( "Query '$query' failed for resultCUA1 in user_functions.php : " . mysql_error() );
	
	while ( $line = mysql_fetch_array( $resultCUA1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultCUA1, $sqloop );
			$status = $col_value;
			$sqloop++;
		}
	}
	
	if ( ( strcmp( $status, "ADMIN" ) == 0 && $superuseronly == FALSE ) 
		|| strcmp( $status, "SUPERUSER" ) == 0 )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

function UserLogout()
{
	require_once( "config.php" );
	
	if ( $_COOKIE["sid"] == NULL )
	{
		UserLogin( "You're already logged-out!" );
		die();
	}
	
	$query = "update users set loggedon='0' where sessionid='" . md5( $_COOKIE["sid"] ) . "'";
	$resultUL1 = mysql_query( $query ) or die( "Query '$query' failed for resultUL1 in user_functions.php " . mysql_error() );
	
	setcookie( "sid", "0", "1" );
	$_COOKIE["sid"] = NULL;
	
	UserLogin( "You have been logged-out successfully!" );
	
	return;
}

function GenerateSID()
{
	$sidsalt = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890-_-_";
	
	$howmany = mt_rand( 50, 100 );
	
	$newsalt = NULL;
	for ( $saltloop = 1; $saltloop <= $howmany; $saltloop++ )
	{
		$whichsalt = mt_rand( 0, strlen( $sidsalt ) - 1 );
		$newsalt .= $sidsalt{$whichsalt};
	}
	
	return $newsalt;
}

function LoadUser( $userid )
{
	require( "config.php" );
	
	if ( !is_numeric( $userid ) || trim( $userid ) == NULL || $userid <= 0 )
	{
		return array( "success" => FALSE, "errmsg" => "Invalid userid - '$userid'!" );
	}
	
	$query = "select * from users where userid='$userid'";
	$resultLU1 = mysql_query( $query ) or die( "Query '$query' failed for resultLU1 in common.php : " . mysql_error() );
	
	$userdata = array();
	while ( $line = mysql_fetch_array( $resultLU1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLU1, $sqloop );
			$userdata[$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( $userid != $userdata["userid"] )
	{
		return array( "success" => FALSE, "errmsg" => "No matching user for userid '$userid'!" );
	}
	
	$userdata["success"] = TRUE;
	
	return $userdata;
}

function LoadUserByUsername( $username )
{
	require( "config.php" );
	
	if ( trim( $username ) == NULL )
	{
		return array( "success" => FALSE, "errmsg" => "Invalid username - '$username'!" );
	}
	
	$query = "select * from users where username='" . addslashes( $username ) . "'";
	$resultLUBU1 = mysql_query( $query ) or die( "Query '$query' failed for resultLUBU1 in common.php : " . mysql_error() );
	
	$userdata = array();
	while ( $line = mysql_fetch_array( $resultLUBU1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLUBU1, $sqloop );
			$userdata[$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( strcasecmp( $username, $userdata["username"] ) )
	{
		return array( "success" => FALSE, "errmsg" => "No matching user for username '$username'!" );
	}
	
	$userdata["success"] = TRUE;
	
	return $userdata;
}

function LoadUserByEmail( $email )
{
	require( "config.php" );
	
	if ( trim( $email ) == NULL || ValidEmail( $email ) == FALSE )
	{
		return array( "success" => FALSE, "errmsg" => "Invalid email - '$email'!" );
	}
	
	$query = "select * from users where email='$email'";
	$resultLUBE1 = mysql_query( $query ) or die( "Query '$query' failed for resultLUBE1 in common.php : " . mysql_error() );
	
	$userdata = array();
	while ( $line = mysql_fetch_array( $resultLUBE1, MYSQL_ASSOC ) )
	{
		$sqloop = 0;
		foreach ( $line as $col_value )
		{
			$fieldname = mysql_field_name( $resultLUBE1, $sqloop );
			$userdata[$fieldname] = $col_value;
			$sqloop++;
		}
	}
	
	if ( strcasecmp( $email, $userdata["email"] ) )
	{
		return array( "success" => FALSE, "errmsg" => "No matching user for email '$email'!" );
	}
	
	$userdata["success"] = TRUE;
	
	return $userdata;
}

function ValidEmail( $email )
{
	if ( trim( $email ) == NULL )
	{
		return FALSE;
	}
	
	$amperfound = FALSE;
	$dotfound = FALSE;
	$saltfound1 = FALSE;
	$saltfound2 = FALSE;
	$saltfound3 = FALSE;
	$emailsalt = "abcdefghijklmnopqrstuvwxyz1234567890-_";
	for ( $saltloop = 0; $saltloop < strlen( $emailsalt ); $saltloop++ )
	{
		if ( strcasecmp( $email{0}, $emailsalt{$saltloop} ) == 0 )
		{
			$saltfound1 = TRUE;
			break;
		}
	}
	for ( $parseloop = 1; $parseloop < strlen( $email ); $parseloop++ )
	{
		if ( $saltfound1 == FALSE )
		{
			break;
		}
		
		if ( strcmp( $email{$parseloop}, "'" ) == 0 
			|| strcmp( $email{$parseloop}, "\"" ) == 0 )
		{
			return FALSE;
		}
		
		if ( strcmp( $email{$parseloop}, "@" ) == 0 )
		{
			if ( $amperfound == FALSE )
			{
				$amperfound = TRUE;
				continue;
			}
			else
			{
				return FALSE;
			}
		}
		if ( strcmp( $email{$parseloop}, "." ) == 0 && $amperfound == TRUE )
		{
			$dotfound = TRUE;
			continue;
		}
		if ( $amperfound == TRUE && $dotfound == TRUE && strcmp( $email{$parseloop - 1}, "." ) == 0 )
		{
			for ( $saltloop = 0; $saltloop < strlen( $emailsalt ); $saltloop++ )
			{
				if ( strcasecmp( $email{$parseloop}, $emailsalt{$saltloop} ) == 0 )
				{
					$saltfound3 = TRUE;
					break;
				}
			}
		}
		else if ( $amperfound == TRUE && strcmp( $email{$parseloop - 1}, "@" ) == 0 )
		{
			for ( $saltloop = 0; $saltloop < strlen( $emailsalt ); $saltloop++ )
			{
				if ( strcasecmp( $email{$parseloop}, $emailsalt{$saltloop} ) == 0 )
				{
					$saltfound2 = TRUE;
					break;
				}
			}
		}
	}
	
	if ( $amperfound == FALSE || $dotfound == FALSE || $saltfound1 == FALSE || $saltfound2 == FALSE || $saltfound3 == FALSE )
	{
		return FALSE;
	}
	else
	{
		return TRUE;
	}
}
